/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SecondOrderBisection;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import core.section;

/**
 *
 * @author pchr
 */
public class domain {
    private Map<Integer,box> theBoxesPrevious;
    private Map<Integer,box> theBoxesCurrent;
    private test theEQS;
    private boolean SolutionExistence;
    private boolean converged=false;
    private section theSection;
    private int grid;
    //theBoxes=new HashMap<Integer,box>();
    
    public domain(){}
    
    public domain(double[] x , section theSection, int grid){
        this.grid=grid;
        this.theSection=theSection;
        theEQS = new test(theSection);
        box abox = new box(x[0],x[1],x[2],x[3]);
        SolutionExistence=theEQS.checkBox(abox);
        converged=theEQS.convergedBox(abox);
        theBoxesPrevious=new HashMap<Integer,box>();
        theBoxesPrevious.put(abox.getId(), abox);
    }
    
    public boolean getSolutionExistence(){
        return this.SolutionExistence;
    }
    
    public void solve(){
        theBoxesCurrent=new HashMap<Integer,box>();
        point[] theVerteces = new point[4];
        box theBox;
        box newBox;
        double xl,xu,yl,yu;
        double x1,x2,y1,y2;
        int count=0;
        while(!converged && count<100 && theBoxesPrevious.size()>=1){
            ++count;
            //System.out.println("count = "+count);
            for(Iterator<box> it=theBoxesPrevious.values().iterator(); it.hasNext();){
                theBox = it.next();
                theVerteces=theBox.getVerteces();
                xl=theVerteces[0].getX();
                xu=theVerteces[1].getX();
                yl=theVerteces[0].getY();
                yu=theVerteces[3].getY();
                
                
                for(int i=0;i<grid;i++){
                    for(int j=0; j<grid; j++){
                        x1=xl+(xu-xl)*i/grid;
                        x2=x1+(xu-xl)/grid;
                        y1=yl+(yu-yl)*j/grid;
                        y2=y1+(yu-yl)/grid;
                        newBox = new box(x1,x2,y1,y2);
                        if(theEQS.convergedBox(newBox)){this.converged=true;}
                        if(theEQS.checkBox(newBox)){theBoxesCurrent.put(newBox.getId(), newBox);}
                    }
                }
            }
            theBoxesPrevious.clear();
            for(Iterator<box> it=theBoxesCurrent.values().iterator(); it.hasNext();){
                theBox = it.next();
                theBoxesPrevious.put(theBox.getId(), theBox);
            }
            theBoxesCurrent.clear();
        }
    }
    
    public int getNumOfBoxes(){
        return theBoxesPrevious.size();
    }
    
    public int getNumOfDifSol(){
        int NumOfDifSol=0;
        int numOfBoxes=theBoxesPrevious.size(); if(numOfBoxes>0){NumOfDifSol=1;}
        double[] solX = new double[numOfBoxes];
        double[] solY = new double[numOfBoxes];
        
        double solXPrev=0., solYPrev=0.;
        double solXCurr=0., solYCurr=0.;
        
        box theBox;
        int i=0;
        for(Iterator<box> it=theBoxesPrevious.values().iterator(); it.hasNext();){
            theBox = it.next();
            solX[i]+=theBox.getVerteces()[0].getX();
            solX[i]+=theBox.getVerteces()[1].getX();
            solX[i]+=theBox.getVerteces()[2].getX();
            solX[i]+=theBox.getVerteces()[3].getX();
            
            solY[i]+=theBox.getVerteces()[0].getY();
            solY[i]+=theBox.getVerteces()[1].getY();
            solY[i]+=theBox.getVerteces()[2].getY();
            solY[i]+=theBox.getVerteces()[3].getY();
            
            solXCurr=solX[i]/4.; solYCurr=solY[i]/4.;
            
            ++i;

            if(i==1){solXPrev=solXCurr; solYPrev=solYCurr;}
            if( Math.sqrt( (solXPrev-solXCurr)*(solXPrev-solXCurr)+(solYPrev-solYCurr)*(solYPrev-solYCurr) )>1.E-3 ){
                ++NumOfDifSol;
            }
            solXPrev=solXCurr; solYPrev=solYCurr;
        }
        
        return NumOfDifSol;
    }
    
    public double[] getSolution(){
        int numOfBoxes=theBoxesPrevious.size();
        double[] solX = new double[numOfBoxes];
        double[] solY = new double[numOfBoxes];
        double[] sol = new double[2];
        sol[0]=0.0; sol[1]=0.0;
        box theBox;
        int i=0;
        int j=0;
        for(Iterator<box> it=theBoxesPrevious.values().iterator(); it.hasNext();){
            theBox = it.next();
            solX[i]+=theBox.getVerteces()[0].getX();
            solX[i]+=theBox.getVerteces()[1].getX();
            solX[i]+=theBox.getVerteces()[2].getX();
            solX[i]+=theBox.getVerteces()[3].getX();
            
            solY[i]+=theBox.getVerteces()[0].getY();
            solY[i]+=theBox.getVerteces()[1].getY();
            solY[i]+=theBox.getVerteces()[2].getY();
            solY[i]+=theBox.getVerteces()[3].getY();
            
            

            if( Math.abs((solX[i]+solY[i])/4.-theSection.get_max()) >=1.e-7 && Math.abs((solX[i]-solY[i])/4.-theSection.get_min()) >=1.e-7){
                ++j;
                sol[0]+=solX[i];
                sol[1]+=solY[i];
            }
            
            ++i;
        }
        
        /*for(int j=0; j<numOfBoxes; j++){
            sol[0]+=solX[j];
            sol[1]+=solY[j];
        }*/
        
        //sol[0]=sol[0]/(numOfBoxes*4.);
        //sol[1]=sol[1]/(numOfBoxes*4.);
        sol[0]=sol[0]/(4.*j);
        sol[1]=sol[1]/(4.*j);
        return sol;
    }
    
    public void printSolutionsInBoxes(){
        int numOfBoxes=theBoxesPrevious.size();
        double[] solX = new double[numOfBoxes];
        double[] solY = new double[numOfBoxes];
        
        
        box theBox;
        int i=0;
        for(Iterator<box> it=theBoxesPrevious.values().iterator(); it.hasNext();){
            theBox = it.next();
            solX[i]+=theBox.getVerteces()[0].getX();
            solX[i]+=theBox.getVerteces()[1].getX();
            solX[i]+=theBox.getVerteces()[2].getX();
            solX[i]+=theBox.getVerteces()[3].getX();
            
            solY[i]+=theBox.getVerteces()[0].getY();
            solY[i]+=theBox.getVerteces()[1].getY();
            solY[i]+=theBox.getVerteces()[2].getY();
            solY[i]+=theBox.getVerteces()[3].getY();
            
            
            ++i;
            
            System.out.println("sol "+i+" "+solX[i-1]/4.+" "+solY[i-1]/4.);
        }

    }
    
    public boolean getConvergence(){
        return this.converged;
    }
    
    public void setConvergence(boolean con){
        this.converged=con;
    }
    
    public void setGrid(int gr){
        this.grid=gr;
    }

}
