/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

/**
 *
 * @author pchr
 */
public class State{
    private double MomentState;
    private double curvature;
    private double h1State;
    private double z1State;
    private int id;
    private static int numOfStates;
    private int typeof=2; // 0 for yield 1 for collapse
                          // 2 if My<M<Mp and 3 if M<My
    private section StateSection;
    
    public State(){}
    
    public State(double m, double h, double z, double k){
        this.id=++numOfStates;
        this.MomentState=m;
        this.h1State=h;
        this.z1State=z;
        this.curvature=k;
    }
    
    public State(double m, double h, double z){
        this.id=++numOfStates;
        this.MomentState=m;
        this.h1State=h;
        this.z1State=z;
    }
    
    public void setSection(section thesSec){
        this.StateSection=thesSec;
    }
    
    public void setType(int t){
        this.typeof=t;
    }
    
    public double getMoment(){
        return this.MomentState;
    }
    
    public double getCurvature(){
        return this.curvature;
    }
    
    public double getZ1(){
        return this.z1State;
    }
    
    public double getH1(){
        return this.h1State;
    }
    
    public int getType(){
        return this.typeof;
    }
    
    public int getId(){
        return this.id;
    }
    
    public double getStress(int pos){
        double s=0.0;
        switch(pos){
            case 1:
                if(this.typeof==0 || this.typeof==3){
                    s=-1000.*this.MomentState*(this.StateSection.get_max()-this.StateSection.getYs())/this.StateSection.getIxs();
                }
                if(this.typeof==2){
                    if(this.h1State+this.z1State<=this.StateSection.get_max()){
                        s=-this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                    }else{
                        s=-this.StateSection.getMaterial().getSyield()*Math.signum(MomentState)*(this.StateSection.get_max()-this.h1State)/this.z1State;
                    }
                }else if(this.typeof==1){
                    s=-this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                }
                break;
            case 2:
                if(this.typeof==2 || this.typeof==1){
                    s=-this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                }
                break;
            case 3:
                if(this.typeof==2 || this.typeof==1){
                    s=this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                }
                break;
            case 4:
                if(this.typeof==0 || this.typeof==3){
                    s=1000.*this.MomentState*(-this.StateSection.get_min()+this.StateSection.getYs())/this.StateSection.getIxs();
                }
                if(this.typeof==2){
                    if(this.h1State-this.z1State>=this.StateSection.get_min()){
                        s=this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                    }else{
                        s=this.StateSection.getMaterial().getSyield()*Math.signum(MomentState)*(this.StateSection.get_min()+this.h1State)/this.z1State;
                    }
                }else if(this.typeof==1){
                    s=this.StateSection.getMaterial().getSyield()*Math.signum(MomentState);
                }
                break;
        }
        return s;
    }
    
    public void clear(){
        State.numOfStates=0;
    }
}
