/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.StateComparator;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 *
 * @author pchr
 */
public class MomCurvPanel extends DrawPanel{
    
    public MomCurvPanel(){
        super();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xm=width/2;
        xs=width/20;
        xe=width-width/20;
        ym=height/2;
        ys=height/20;
        ye=height-height/20;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, ye, xe, ye);
        g2.drawLine(xe, ye, xe-10, ye-5);
        g2.drawLine(xe, ye, xe-10, ye+5);
        g2.drawString("καμπυλότητα", xe-10, ye-10);
        g2.drawLine(xs, ye, xs, ys);
        g2.drawLine(xs, ys, xs-5, ys+10);
        g2.drawLine(xs, ys, xs+5, ys+10);
        g2.drawString("ροπή", xs-30, ys+20);
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00E0",comma);
        String sd;
        
        if(this.thesection!=null){
            List<core.State> list = new ArrayList<core.State>();
            Map<Integer,core.State> theStates = thesection.getStates();
            int numOfstates=theStates.size();
            if(numOfstates>1){
                for(Iterator<core.State> it=theStates.values().iterator(); it.hasNext();){
                    core.State aState = it.next();
                    list.add(aState);
                }
                Collections.sort( list,new StateComparator() );
                g2.setColor(Color.WHITE);
                int ls=list.size();
                int xx,yy;
                xx=xs+(int) ((xe-xs) * list.get(0).getCurvature() / list.get(ls-2).getCurvature());
                yy=ye-(int) ((ye-ys) * list.get(0).getMoment() / list.get(ls-1).getMoment());
                g2.drawLine(xs, ye,xx,yy);
                g2.setColor(Color.RED);
                g2.fillArc(xs-2, ye-2, 4, 4, 0, 360);
                for(int i=0;i<ls-2;i++) {
                    g2.setColor(Color.WHITE);
                    g2.drawLine(xs+(int) ((xe-xs) * list.get(i).getCurvature() / list.get(ls-2).getCurvature()),
                                ye-(int) ((ye-ys) * list.get(i).getMoment() / list.get(ls-1).getMoment()),
                                xs+(int) ((xe-xs) * list.get(i+1).getCurvature() / list.get(ls-2).getCurvature()), 
                                ye-(int) ((ye-ys) * list.get(i+1).getMoment() / list.get(ls-1).getMoment())
                        );
                }
                
                for(int i=0;i<ls-1;i++) {
                    g2.setColor(Color.WHITE);
                    if(list.get(i).getType()==0){
                        sd=Places.format(list.get(i).getMoment());
                        g2.drawString(sd, xs-30, ye-(int) ((ye-ys) * list.get(i).getMoment() / list.get(ls-1).getMoment()));
                        sd=Places.format(list.get(i).getCurvature());
                        g2.drawString(sd, xs+(int) ((xe-xs) * list.get(i).getCurvature() / list.get(ls-2).getCurvature()), ye+30);
                    }
                    g2.setColor(Color.RED);
                    g2.fillArc(xs+(int) ((xe-xs) * list.get(i).getCurvature() / list.get(ls-2).getCurvature())-2, 
                            ye-(int) ((ye-ys) * list.get(i).getMoment() / list.get(ls-1).getMoment())-2, 4, 4, 0, 360);
                }

                g2.setColor(Color.LIGHT_GRAY);
                yy=ye-(int) ((ye-ys) * list.get(ls-1).getMoment() / list.get(ls-1).getMoment());
                g2.drawLine(xs, yy,xe,yy);
                g2.setColor(Color.WHITE);
                sd=Places.format(list.get(ls-1).getMoment());
                g2.drawString(sd, xs-30, yy);
            }

        }
    }

}
