/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.util.Map;
import core.*;
import java.awt.geom.Point2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Iterator;

/**
 *
 * @author pchr
 */
public class SectionPanel extends DrawPanel{
    boolean plot_points=false;
    boolean plot_lines=false;
    boolean plot_state=false;
    int selectedState=-1;
    
    public SectionPanel(){
        super();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.BLACK);
        //g2.setBackground(Color.WHITE);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xm=width/5;
        xs=width/20;
        xe=width-width/20;
        ym=height/2;
        ys=height/20;
        ye=height-height/20;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, ym, xe, ym);
        g2.drawLine(xm, ys, xm, ye);
        g2.drawLine(xm, ye, xm-5, ye-10);
        g2.drawLine(xm, ye, xm+5, ye-10);
        g2.drawString("z", xm+10, ye+10);
        g2.drawLine(xs, ym, xs+10, ym-5);
        g2.drawLine(xs, ym, xs+10, ym+5);
        g2.drawString("y", xs-10, ym-10);
       
        this.drawNumericAxis(g2);
        if(this.thesection!=null){
            
            this.yscale=(0.5*Math.abs(ys-ye))/(Math.abs(thesection.get_min())+Math.abs(thesection.get_max()));
            
            
            at = new AffineTransform();
                    
            at.translate(xm, ym);
            
            at.rotate(Math.PI);
            
            at.scale(yscale, yscale);
            
            
            if(plot_lines) this.drawLines(g2);
            if(plot_points) this.drawPoints(g2);
            if(plot_state) this.drawState(g2);
            //this.drawNeutral(g2);
            
            
        }
    }
     
     public void drawLines(Graphics2D g2){
        int x1,x2,y1,y2;
        Map<Integer,line> theLines=thesection.getLines();
        for(Iterator<line> it=theLines.values().iterator(); it.hasNext();){
            line theLine = it.next();
            Point2D.Double pointb,pointa;
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(theLine.getP1().getX(),theLine.getP1().getY());
            at.transform(pointb, pointa);
            
            x1=(int) pointa.getX();
            y1=(int) pointa.getY();
            
            pointb = new Point2D.Double(theLine.getP2().getX(),theLine.getP2().getY());
            at.transform(pointb, pointa);
            
            x2=(int) pointa.getX();
            y2=(int) pointa.getY();

            g2.setColor(Color.GREEN);
            //g2.setColor(Color.BLACK);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            //g2.drawString(Integer.toString(theLine.getId()), (x2+x1)/2, (y1+y2)/2);
        }
    }
     
     public void drawPoints(Graphics2D g2){
        int x1,y1;
        Map<Integer,point> thePoints=thesection.getPoints();
        for(Iterator<point> it=thePoints.values().iterator(); it.hasNext();){
            point thePoint = it.next();
            Point2D.Double pointb,pointa;
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(thePoint.getX(),thePoint.getY());
            at.transform(pointb, pointa);
            
            x1=(int) pointa.getX();
            y1=(int) pointa.getY();
            
            

            g2.setColor(Color.RED);
            g2.setStroke(new BasicStroke(1));
            g2.fillArc(x1-2, y1-2, 4, 4, 0, 360);
            //g2.drawString(Integer.toString(thePoint.getId()), x1+2, y1-2);
        }
        
        
        Point2D.Double pointb,pointa;
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.0,thesection.getYs());
        at.transform(pointb, pointa);
        x1=(int) pointa.getX();
        y1=(int) pointa.getY();
        g2.setColor(Color.ORANGE);
        g2.setStroke(new BasicStroke(1));
        g2.fillArc(x1-2, y1-2, 4, 4, 0, 360);
        g2.drawString("K", x1+2, y1-2);
    }
     
     public void drawState(Graphics2D g2){
         if(this.selectedState>0){
             int x1,x2,y1,y2;
             double val,valz;
             Point2D.Double pointb,pointa;

             pointa = new Point2D.Double();
             val=thesection.getStates().get(this.selectedState).getH1();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x1=(int) pointa.getX();
             y1=(int) pointa.getY();

             pointb = new Point2D.Double(-1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x2=(int) pointa.getX();
             y2=(int) pointa.getY();

             g2.setColor(Color.YELLOW);
             g2.setStroke(new BasicStroke(1));
             g2.drawLine(x1, y1, x2, y2);
             g2.drawString("h1", 9*x2/10, 11*y2/10);

             if(thesection.getStates().get(this.selectedState).getZ1()>1.e-5){
                 //     z1_down
                 if(val-thesection.getStates().get(this.selectedState).getZ1()>=thesection.get_min()){
                     pointa = new Point2D.Double();
                     valz=thesection.getStates().get(this.selectedState).getZ1();
                     pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val-valz));
                     at.transform(pointb, pointa);
                     x1=(int) pointa.getX();
                     y1=(int) pointa.getY();

                     pointb = new Point2D.Double(-1.1*thesection.get_b()/2.,(val-valz));
                     at.transform(pointb, pointa);
                     x2=(int) pointa.getX();
                     y2=(int) pointa.getY();

                     g2.setColor(Color.ORANGE);
                     g2.setStroke(new BasicStroke(1));
                     g2.drawLine(x1, y1, x2, y2);
                     g2.drawString("z1_κάτω", 9*x2/10, 11*y2/10); 
                 }
                 
                 //     z1_θπ
                 if(val+thesection.getStates().get(this.selectedState).getZ1()<=thesection.get_max()){
                     pointa = new Point2D.Double();
                     valz=thesection.getStates().get(this.selectedState).getZ1();
                     pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val+valz));
                     at.transform(pointb, pointa);
                     x1=(int) pointa.getX();
                     y1=(int) pointa.getY();

                     pointb = new Point2D.Double(-1.1*thesection.get_b()/2.,(val+valz));
                     at.transform(pointb, pointa);
                     x2=(int) pointa.getX();
                     y2=(int) pointa.getY();

                     g2.setColor(Color.ORANGE);
                     g2.setStroke(new BasicStroke(1));
                     g2.drawLine(x1, y1, x2, y2);
                     g2.drawString("z1_άνω", 9*x2/10, 11*y2/10);
                 }
                 
             }
             // edo
             double s1=0.,s2=0.,s3=0.,s4=0.;
             
             int use2=0,use3=0;
             if(thesection.getStates().get(this.selectedState).getH1()+thesection.getStates().get(this.selectedState).getZ1()<thesection.get_max()) use2=1;
             if(thesection.getStates().get(this.selectedState).getH1()-thesection.getStates().get(this.selectedState).getZ1()>thesection.get_min()) use3=1;
             if(thesection.getStates().get(this.selectedState).getType()==1){use2=1;use3=1;}
             if(thesection.getStates().get(this.selectedState).getType()==0 ||
                     thesection.getStates().get(this.selectedState).getType()==3){use2=0;use3=0;}
             switch(thesection.getStates().get(this.selectedState).getType()){
                 case 0:
                     s1=thesection.getStates().get(this.selectedState).getStress(1);
                     s4=thesection.getStates().get(this.selectedState).getStress(4);
                     break;
                 case 3:
                     s1=thesection.getStates().get(this.selectedState).getStress(1);
                     s4=thesection.getStates().get(this.selectedState).getStress(4);
                     break;
                 case 2:
                     s1=thesection.getStates().get(this.selectedState).getStress(1);
                     s2=thesection.getStates().get(this.selectedState).getStress(2);
                     s3=thesection.getStates().get(this.selectedState).getStress(3);
                     s4=thesection.getStates().get(this.selectedState).getStress(4);
                     break;
                 case 1:
                     s1=thesection.getStates().get(this.selectedState).getStress(1);
                     s2=thesection.getStates().get(this.selectedState).getStress(2);
                     s3=thesection.getStates().get(this.selectedState).getStress(3);
                     s4=thesection.getStates().get(this.selectedState).getStress(4);
                     break;
             }
             double e1=0.,e4=0.,e=0.;
             if(thesection.getStates().get(this.selectedState).getType()==0 ||
                     thesection.getStates().get(this.selectedState).getType()==3){
                 e1=s1/thesection.getMaterial().getE();
                 e4=s4/thesection.getMaterial().getE();
             }else{
                 e1=-Math.signum(thesection.getStates().get(this.selectedState).getMoment())*thesection.getMaterial().getSyield()*(thesection.get_max()-thesection.getStates().get(this.selectedState).getH1())/
                         (thesection.getMaterial().getE()*thesection.getStates().get(this.selectedState).getZ1());
                 e4=-Math.signum(thesection.getStates().get(this.selectedState).getMoment())*thesection.getMaterial().getSyield()*(thesection.get_min()-thesection.getStates().get(this.selectedState).getH1())/
                         (thesection.getMaterial().getE()*thesection.getStates().get(this.selectedState).getZ1());
             }
             e1/=1000.; e4/=1000.;
             e=Math.max(Math.abs(e1), Math.abs(e4));
             
             double s=Math.max(Math.abs(s1), Math.abs(s4));
             s=Math.max(Math.abs(s), Math.abs(s3));
             s=Math.max(Math.abs(s), Math.abs(s2));
             g2.setColor(Color.WHITE);
             
             val=thesection.get_max();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x1=(int) pointa.getX();
             y1=(int) pointa.getY();
             val=thesection.get_min();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x2=(int) pointa.getX();
             y2=(int) pointa.getY();
             
             int y3,y4;
             val=thesection.getStates().get(this.selectedState).getZ1()+thesection.getStates().get(this.selectedState).getH1();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x2=(int) pointa.getX();
             y3=(int) pointa.getY();
             val=-thesection.getStates().get(this.selectedState).getZ1()+thesection.getStates().get(this.selectedState).getH1();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x2=(int) pointa.getX();
             y4=(int) pointa.getY();
             
             DecimalFormatSymbols comma =new DecimalFormatSymbols();
             comma.setDecimalSeparator('.');
             DecimalFormat Places = new DecimalFormat("0.00E0",comma);
             String sd;
             
             g2.drawLine(xm+350, y1,(int) (xm+350 + 100 * s1 / s), y1);
             sd=Places.format(s1);
             g2.drawString(sd, (int) (xm+350 + 100 * s1 / s), y1-10);
             g2.drawLine(xm+350, y2,(int) (xm+350 + 100 * s4 / s), y2);
             sd=Places.format(s4);
             g2.drawString(sd, (int) (xm+350 + 100 * s4 / s), y2+10);
             if(use2==1){
                 g2.drawLine((int) (xm+350 + 100 * s1 / s), y1,(int) (xm+350 + 100 * s2 / s), y3);
                 sd=Places.format(s2);
                 g2.drawString(sd, (int) (xm+350 + 100 * s2 / s), y3);
             }
             if(use3==1 && use2==1){
                 g2.drawLine((int) (xm+350 + 100 * s2 / s), y3,(int) (xm+350 + 100 * s3 / s), y4);
                 sd=Places.format(s3);
                 g2.drawString(sd, (int) (xm+350 + 100 * s3 / s), y4);
                 g2.drawLine((int) (xm+350 + 100 * s3 / s), y4,(int) (xm+350 + 100 * s4 / s), y2);
             }
             if(use3==1 && use2==0){
                 g2.drawLine((int) (xm+350 + 100 * s1 / s), y1,(int) (xm+350 + 100 * s3 / s), y4);
                 sd=Places.format(s3);
                 g2.drawString(sd, (int) (xm+350 + 100 * s3 / s), y4);
                 g2.drawLine((int) (xm+350 + 100 * s3 / s), y4,(int) (xm+350 + 100 * s4 / s), y2);
             }
             if(use3==0 && use2==1){
                 g2.drawLine((int) (xm+350 + 100 * s2 / s), y3,(int) (xm+350 + 100 * s4 / s), y2);
             }
             if(use3==0 && use2==0){
                 g2.drawLine((int) (xm+350 + 100 * s1 / s), y1,(int) (xm+350 + 100 * s4 / s), y2);
             }
             
             sd=Places.format(thesection.getStates().get(this.selectedState).getMoment());
             g2.drawString("ροπή : "+sd, this.getWidth()/2-50, ye);
             val=thesection.get_max();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x1=(int) pointa.getX();
             y1=(int) pointa.getY();
             val=thesection.get_min();
             pointb = new Point2D.Double(1.1*thesection.get_b()/2.,(val));
             at.transform(pointb, pointa);
             x2=(int) pointa.getX();
             y2=(int) pointa.getY();
             if(thesection.getStates().get(this.selectedState).getType()!=1){
                 g2.drawLine(4*xm, y1,(int) (4*xm + 100 * e1 / e), y1);
                 sd=Places.format(e1);
                 g2.drawString(sd, (int) (4*xm + 100 * e1 / e), y1-10);
                 g2.drawLine(4*xm, y2,(int) (4*xm + 100 * e4 / e), y2);
                 sd=Places.format(e4);
                 g2.drawString(sd, (int) (4*xm + 100 * e4 / e), y2+10);
                 g2.drawLine((int) (4*xm + 100 * e1 / e), y1,(int) (4*xm + 100 * e4 / e), y2);
             }else{
                 g2.drawString("άπειρο", 4*xm, y1-10);
                 g2.drawString("άπειρο", 4*xm, y2+10);
             }
             
         }
     }
     
     private void drawNeutral(Graphics2D g2){
         int x1,x2,y1,y2;
         Point2D.Double pointb,pointa;
         
         pointa = new Point2D.Double();
         pointb = new Point2D.Double(1.1*thesection.get_b()/2.,1.1*thesection.getYs());
         at.transform(pointb, pointa);
         x1=(int) pointa.getX();
         y1=(int) pointa.getY();
         
         pointb = new Point2D.Double(-1.1*thesection.get_b()/2.,1.1*thesection.getYs());
         at.transform(pointb, pointa);
         x2=(int) pointa.getX();
         y2=(int) pointa.getY();
         
         g2.setColor(Color.WHITE);
         g2.setStroke(new BasicStroke(1));
         g2.drawLine(x1, y1, x2, y2);
         g2.drawString("ουδέτερη γραμμή", 9*x2/10, 11*y2/10);
     }
     
     private void drawNumericAxis(Graphics2D g2) {
         g2.setColor(Color.DARK_GRAY);
         g2.drawLine(xm+350, ys, xm+350, ye);
         g2.drawString("κατανομή τάσεων", xm+300, ys-20);
         g2.drawLine(4*xm, ys, 4*xm, ye);
         g2.drawString("κατανομή τροπών", 4*xm-50, ys-20);
         
     }
     
     public void switch_plot_points(){
         if(this.plot_points==false){this.plot_points=true;}else{this.plot_points=false;}
     }
     
     public void switch_plot_lines(){
         if(this.plot_lines==false){this.plot_lines=true;}else{this.plot_lines=false;}
     }
     
     public void switch_plot_states(){
         if(this.plot_state==false){this.plot_state=true;}else{this.plot_state=false;}
     }
     
     public void set_plot_points(boolean p){
         this.plot_points=p;
     }
     
     public void set_plot_lines(boolean p){
         this.plot_lines=p;
     }
     
     public void set_plot_states(boolean p){
         this.plot_state=p;
     }
     
     public void setSelectedState(int s){
         this.selectedState=s;
     }

}
